//+------------------------------------------------------------------+
//|                              Auto-Pivot Plotter Weekly V1-00.mq4 |
//|                                  Copyright  2007, BundyRaider   |
//|                                                                  |
//+------------------------------------------------------------------+
#property link      ""


#property indicator_chart_window
#property indicator_buffers 7

#property indicator_color1 Navy
#property indicator_color2 Blue
#property indicator_color3 DodgerBlue
#property indicator_color4 WhiteSmoke
#property indicator_color5 Orange
#property indicator_color6 Red
#property indicator_color7 FireBrick

#property indicator_style2 STYLE_DOT
#property indicator_style3 STYLE_DOT
#property indicator_style4 STYLE_DOT
#property indicator_style5 STYLE_DOT
#property indicator_style6 STYLE_DOT
#property indicator_style7 STYLE_DOT



extern int        WeeksToPlot = 1;
extern bool       ChangeToFibonacci=False;

double Res3[];
double Res2[];
double Res1[];
double Pivot[];
double Supp1[];
double Supp2[];
double Supp3[];

int init()
{
   if (Period() > PERIOD_D1)
      return(1);

   SetIndexBuffer(0,Res3);
   SetIndexLabel(0,"Weekly R3 Mid");
   SetIndexBuffer(1,Res2);
   SetIndexLabel(1,"Weekly R2 Mid");
   SetIndexBuffer(2,Res1);
   SetIndexLabel(2,"Weekly R1 Mid");
   SetIndexBuffer(3,Pivot);
   SetIndexLabel(3,"Weekly Pivot");
   SetIndexBuffer(4,Supp1);
   SetIndexLabel(4,"Weekly S1 Mid");
   SetIndexBuffer(5,Supp2);
   SetIndexLabel(5,"Weekly S2 Mid");
   SetIndexBuffer(6,Supp3);
   SetIndexLabel(6,"Weekly S3 Mid");
   
   IndicatorDigits(Digits);

   return(0);
}


int deinit()
{
   return(0);
}


int start()
{
   int    counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

//   int limit=Bars-counted_bars;
   int limit = Bars;
   
   int PreviousWeeklyBar = -1;
   int WeeksPlotted = -1;
   
   for(int i=0; i<limit; i++)
   { 
      datetime WeekDate=Time[i];
      int WeeklyBar        =  iBarShift( NULL, PERIOD_W1, WeekDate,false)+1; 
      
      if (WeeksToPlot > 0)
      {
         if (PreviousWeeklyBar != WeeklyBar)
         {
            WeeksPlotted++;
            PreviousWeeklyBar = WeeklyBar;
         }
      
         if (WeeksPlotted >= WeeksToPlot)
         {
            if (WeeksToPlot == 1 && Pivot[0] != Pivot[1])
            {
               Pivot[1] = Pivot[0];
               Res1[1] =Res1[0];
               Res2[1] =Res2[0];
               Res3[1] =Res3[0];
               Supp1[1]=Supp1[0];
               Supp2[1]=Supp2[0];
               Supp3[1]=Supp3[0];
            }
            return (0);
         }
      }
      
      double PreviousHigh  =  iHigh(NULL, PERIOD_W1,WeeklyBar);
      double PreviousLow   =  iLow(NULL, PERIOD_W1,WeeklyBar);
      double PreviousClose =  iClose(NULL, PERIOD_W1,WeeklyBar);


      
      if(ChangeToFibonacci==False)
      {
         double P =  (PreviousHigh+PreviousLow+PreviousClose)/3;
         double R1 = (2*P)-PreviousLow;
         double S1 = (2*P)-PreviousHigh;
         double R2 =  P+(PreviousHigh - PreviousLow);
         double S2 =  P-(PreviousHigh - PreviousLow);
         double R3 = (2*P)+(PreviousHigh-(2*PreviousLow));
         double S3 = (2*P)-((2* PreviousHigh)-PreviousLow); 
      }
      else
      {
         P  =  (PreviousHigh+PreviousLow+PreviousClose)/3;
         R1 = P + ((PreviousHigh-PreviousLow) * 0.382);
         S1 = P - ((PreviousHigh-PreviousLow) * 0.382);
         R2 = P + ((PreviousHigh-PreviousLow) * 0.618);
         S2 = P - ((PreviousHigh-PreviousLow) * 0.618);
         R3 = P + ((PreviousHigh-PreviousLow) * 1.000);
         S3 = P - ((PreviousHigh-PreviousLow) * 1.000);
      } 
     
      Pivot[i]=      NormalizeDouble( P, Digits); 
      Res1[i] =((R1-P)/2)+P;    //M3
      Res2[i] =((R2-R1)/2)+R1;  //M4
      Res3[i] =((R3-R2)/2)+R2;  
      Supp1[i]=((P-S1)/2)+S1;   //M2
      Supp2[i]=((S1-S2)/2)+S2;  //M1
      Supp3[i]=((S2-S3)/2)+S3;

   }

   return(0);
}